/* game-config.c generated by valac 0.56.9, the Vala compiler
 * generated from game-config.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GAME_CONFIG (game_config_get_type ())
typedef struct _GameConfig GameConfig;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define TYPE_GAME_CONFIGS (game_configs_get_type ())
#define GAME_CONFIGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_CONFIGS, GameConfigs))
#define GAME_CONFIGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_CONFIGS, GameConfigsClass))
#define IS_GAME_CONFIGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_CONFIGS))
#define IS_GAME_CONFIGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_CONFIGS))
#define GAME_CONFIGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_CONFIGS, GameConfigsClass))

typedef struct _GameConfigs GameConfigs;
typedef struct _GameConfigsClass GameConfigsClass;
typedef struct _GameConfigsPrivate GameConfigsPrivate;
#define _game_configs_unref0(var) ((var == NULL) ? NULL : (var = (game_configs_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _game_config_free0(var) ((var == NULL) ? NULL : (var = (game_config_free (var), NULL)))
typedef struct _ParamSpecGameConfigs ParamSpecGameConfigs;

struct _GameConfig {
	gchar* description;
	gint initial_type1;
	gint initial_type2;
	gint increment_type1;
	gint increment_type2;
	gint maximum_type1;
	gint maximum_type2;
	gint score_type1;
	gint score_type2;
	gint score_type1_waiting;
	gint score_type2_waiting;
	gint score_type1_splatted;
	gint score_type2_splatted;
	gint num_robots_per_safe;
	gint safe_score_boundary;
	gint initial_safe_teleports;
	gint free_safe_teleports;
	gint max_safe_teleports;
	gboolean moveable_heaps;
};

struct _GameConfigs {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameConfigsPrivate * priv;
};

struct _GameConfigsClass {
	GTypeClass parent_class;
	void (*finalize) (GameConfigs *self);
};

struct _GameConfigsPrivate {
	GeeArrayList* game_configs;
};

struct _ParamSpecGameConfigs {
	GParamSpec parent_instance;
};

static gint GameConfigs_private_offset;
static gpointer game_configs_parent_class = NULL;

VALA_EXTERN GType game_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameConfig* game_config_dup (const GameConfig* self);
VALA_EXTERN void game_config_free (GameConfig* self);
VALA_EXTERN void game_config_copy (const GameConfig* self,
                       GameConfig* dest);
VALA_EXTERN void game_config_destroy (GameConfig* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameConfig, game_config_destroy)
VALA_EXTERN gchar* game_config_name (GameConfig *self);
VALA_EXTERN void game_config_from_file (const gchar* filename,
                            GameConfig* result,
                            GError** error);
VALA_EXTERN gpointer game_configs_ref (gpointer instance);
VALA_EXTERN void game_configs_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_game_configs (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_game_configs (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_game_configs (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_game_configs (const GValue* value);
VALA_EXTERN GType game_configs_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameConfigs, game_configs_unref)
VALA_EXTERN GameConfigs* game_configs_new_load (GError** error);
VALA_EXTERN GameConfigs* game_configs_construct_load (GType object_type,
                                          GError** error);
VALA_EXTERN guint game_configs_count (GameConfigs* self);
VALA_EXTERN GameConfig* game_configs_get (GameConfigs* self,
                              guint n);
VALA_EXTERN gchar* game_configs_get_name (GameConfigs* self,
                              guint n);
VALA_EXTERN GameConfig* game_configs_find_by_name (GameConfigs* self,
                                       const gchar* name);
VALA_EXTERN GameConfigs* game_configs_new (void);
VALA_EXTERN GameConfigs* game_configs_construct (GType object_type);
static void game_configs_finalize (GameConfigs * obj);
static GType game_configs_get_type_once (void);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 168 "game-config.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 172 "game-config.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 178 "game-config.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 182 "game-config.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 186 "game-config.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 194 "game-config.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 222 "game-config.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 231 "game-config.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 245 "game-config.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 254 "game-config.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 268 "game-config.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 277 "game-config.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 286 "game-config.c"
}

gchar*
game_config_name (GameConfig *self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 42 "../src/game-config.vala"
	_tmp0_ = (*self).description;
#line 42 "../src/game-config.vala"
	_tmp1_ = string_replace (_tmp0_, "_", " ");
#line 42 "../src/game-config.vala"
	result = _tmp1_;
#line 42 "../src/game-config.vala"
	return result;
#line 303 "game-config.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 326 "game-config.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 335 "game-config.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 354 "game-config.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 358 "game-config.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 364 "game-config.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 374 "game-config.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 382 "game-config.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 386 "game-config.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 392 "game-config.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 402 "game-config.c"
}

void
game_config_from_file (const gchar* filename,
                       GameConfig* result,
                       GError** error)
{
	GameConfig gcfg = {0};
	gchar* _tmp0_;
	GameConfig _tmp1_;
	const gchar* _tmp2_;
	GRegex* line_regex = NULL;
	GRegex* _tmp10_;
	GFile* file = NULL;
	GFile* _tmp11_;
	GFileInputStream* _tmp12_ = NULL;
	GFile* _tmp13_;
	GFileInputStream* _tmp14_;
	GDataInputStream* dis = NULL;
	GDataInputStream* _tmp15_;
	gchar* line = NULL;
	guint pflag = 0U;
	GError* _inner_error0_ = NULL;
#line 45 "../src/game-config.vala"
	g_return_if_fail (filename != NULL);
#line 46 "../src/game-config.vala"
	memset (&gcfg, 0, sizeof (GameConfig));
#line 48 "../src/game-config.vala"
	_tmp0_ = g_path_get_basename (filename);
#line 48 "../src/game-config.vala"
	_g_free0 (gcfg.description);
#line 48 "../src/game-config.vala"
	gcfg.description = _tmp0_;
#line 49 "../src/game-config.vala"
	_tmp1_ = gcfg;
#line 49 "../src/game-config.vala"
	_tmp2_ = _tmp1_.description;
#line 49 "../src/game-config.vala"
	if (g_str_has_suffix (_tmp2_, ".cfg")) {
#line 442 "game-config.c"
		GameConfig _tmp3_;
		const gchar* _tmp4_;
		GameConfig _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
#line 50 "../src/game-config.vala"
		_tmp3_ = gcfg;
#line 50 "../src/game-config.vala"
		_tmp4_ = _tmp3_.description;
#line 50 "../src/game-config.vala"
		_tmp5_ = gcfg;
#line 50 "../src/game-config.vala"
		_tmp6_ = _tmp5_.description;
#line 50 "../src/game-config.vala"
		_tmp7_ = strlen (_tmp6_);
#line 50 "../src/game-config.vala"
		_tmp8_ = _tmp7_;
#line 50 "../src/game-config.vala"
		_tmp9_ = string_substring (_tmp4_, (glong) 0, (glong) (_tmp8_ - 4));
#line 50 "../src/game-config.vala"
		_g_free0 (gcfg.description);
#line 50 "../src/game-config.vala"
		gcfg.description = _tmp9_;
#line 468 "game-config.c"
	}
#line 53 "../src/game-config.vala"
	_tmp10_ = g_regex_new ("^(\\w+)\\s*=\\s*(\\d+)", 0, 0, &_inner_error0_);
#line 53 "../src/game-config.vala"
	line_regex = _tmp10_;
#line 53 "../src/game-config.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/game-config.vala"
		g_propagate_error (error, _inner_error0_);
#line 53 "../src/game-config.vala"
		game_config_destroy (&gcfg);
#line 53 "../src/game-config.vala"
		return;
#line 482 "game-config.c"
	}
#line 55 "../src/game-config.vala"
	_tmp11_ = g_file_new_for_path (filename);
#line 55 "../src/game-config.vala"
	file = _tmp11_;
#line 56 "../src/game-config.vala"
	_tmp13_ = file;
#line 56 "../src/game-config.vala"
	_tmp14_ = g_file_read (_tmp13_, NULL, &_inner_error0_);
#line 56 "../src/game-config.vala"
	_tmp12_ = _tmp14_;
#line 56 "../src/game-config.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/game-config.vala"
		g_propagate_error (error, _inner_error0_);
#line 56 "../src/game-config.vala"
		_g_object_unref0 (file);
#line 56 "../src/game-config.vala"
		_g_regex_unref0 (line_regex);
#line 56 "../src/game-config.vala"
		game_config_destroy (&gcfg);
#line 56 "../src/game-config.vala"
		return;
#line 506 "game-config.c"
	}
#line 56 "../src/game-config.vala"
	_tmp15_ = g_data_input_stream_new ((GInputStream*) _tmp12_);
#line 56 "../src/game-config.vala"
	dis = _tmp15_;
#line 59 "../src/game-config.vala"
	pflag = (guint) 0;
#line 60 "../src/game-config.vala"
	while (TRUE) {
#line 516 "game-config.c"
		gchar* _tmp16_ = NULL;
		GDataInputStream* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		GMatchInfo* match_info = NULL;
		GRegex* _tmp21_;
		const gchar* _tmp22_;
		GMatchInfo* _tmp23_ = NULL;
		gboolean _tmp24_;
		gchar* key = NULL;
		GMatchInfo* _tmp25_;
		gchar* _tmp26_;
		gint val = 0;
		GMatchInfo* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gint _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
#line 60 "../src/game-config.vala"
		_tmp17_ = dis;
#line 60 "../src/game-config.vala"
		_tmp18_ = g_data_input_stream_read_line (_tmp17_, NULL, NULL, &_inner_error0_);
#line 60 "../src/game-config.vala"
		_tmp16_ = _tmp18_;
#line 60 "../src/game-config.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/game-config.vala"
			g_propagate_error (error, _inner_error0_);
#line 60 "../src/game-config.vala"
			_g_free0 (line);
#line 60 "../src/game-config.vala"
			_g_object_unref0 (dis);
#line 60 "../src/game-config.vala"
			_g_object_unref0 (_tmp12_);
#line 60 "../src/game-config.vala"
			_g_object_unref0 (file);
#line 60 "../src/game-config.vala"
			_g_regex_unref0 (line_regex);
#line 60 "../src/game-config.vala"
			game_config_destroy (&gcfg);
#line 60 "../src/game-config.vala"
			return;
#line 577 "game-config.c"
		}
#line 60 "../src/game-config.vala"
		_tmp19_ = _tmp16_;
#line 60 "../src/game-config.vala"
		_tmp16_ = NULL;
#line 60 "../src/game-config.vala"
		_g_free0 (line);
#line 60 "../src/game-config.vala"
		line = _tmp19_;
#line 60 "../src/game-config.vala"
		_tmp20_ = line;
#line 60 "../src/game-config.vala"
		if (!(_tmp20_ != NULL)) {
#line 60 "../src/game-config.vala"
			_g_free0 (_tmp16_);
#line 60 "../src/game-config.vala"
			break;
#line 595 "game-config.c"
		}
#line 62 "../src/game-config.vala"
		_tmp21_ = line_regex;
#line 62 "../src/game-config.vala"
		_tmp22_ = line;
#line 62 "../src/game-config.vala"
		_tmp24_ = g_regex_match (_tmp21_, _tmp22_, 0, &_tmp23_);
#line 62 "../src/game-config.vala"
		_g_match_info_unref0 (match_info);
#line 62 "../src/game-config.vala"
		match_info = _tmp23_;
#line 62 "../src/game-config.vala"
		if (!_tmp24_) {
#line 63 "../src/game-config.vala"
			_g_match_info_unref0 (match_info);
#line 63 "../src/game-config.vala"
			_g_free0 (_tmp16_);
#line 63 "../src/game-config.vala"
			continue;
#line 615 "game-config.c"
		}
#line 65 "../src/game-config.vala"
		_tmp25_ = match_info;
#line 65 "../src/game-config.vala"
		_tmp26_ = g_match_info_fetch (_tmp25_, 1);
#line 65 "../src/game-config.vala"
		key = _tmp26_;
#line 66 "../src/game-config.vala"
		_tmp27_ = match_info;
#line 66 "../src/game-config.vala"
		_tmp28_ = g_match_info_fetch (_tmp27_, 2);
#line 66 "../src/game-config.vala"
		_tmp29_ = _tmp28_;
#line 66 "../src/game-config.vala"
		_tmp30_ = atoi (_tmp29_);
#line 66 "../src/game-config.vala"
		_g_free0 (_tmp29_);
#line 66 "../src/game-config.vala"
		val = _tmp30_;
#line 68 "../src/game-config.vala"
		_tmp31_ = key;
#line 68 "../src/game-config.vala"
		if (g_strcmp0 (_tmp31_, "initial_type1") == 0) {
#line 69 "../src/game-config.vala"
			gcfg.initial_type1 = val;
#line 70 "../src/game-config.vala"
			pflag |= (guint) 0x00000001;
#line 643 "game-config.c"
		}
#line 72 "../src/game-config.vala"
		_tmp32_ = key;
#line 72 "../src/game-config.vala"
		if (g_strcmp0 (_tmp32_, "initial_type2") == 0) {
#line 73 "../src/game-config.vala"
			gcfg.initial_type2 = val;
#line 74 "../src/game-config.vala"
			pflag |= (guint) 0x00000002;
#line 653 "game-config.c"
		}
#line 76 "../src/game-config.vala"
		_tmp33_ = key;
#line 76 "../src/game-config.vala"
		if (g_strcmp0 (_tmp33_, "increment_type1") == 0) {
#line 77 "../src/game-config.vala"
			gcfg.increment_type1 = val;
#line 78 "../src/game-config.vala"
			pflag |= (guint) 0x00000004;
#line 663 "game-config.c"
		}
#line 80 "../src/game-config.vala"
		_tmp34_ = key;
#line 80 "../src/game-config.vala"
		if (g_strcmp0 (_tmp34_, "increment_type2") == 0) {
#line 81 "../src/game-config.vala"
			gcfg.increment_type2 = val;
#line 82 "../src/game-config.vala"
			pflag |= (guint) 0x00000008;
#line 673 "game-config.c"
		}
#line 84 "../src/game-config.vala"
		_tmp35_ = key;
#line 84 "../src/game-config.vala"
		if (g_strcmp0 (_tmp35_, "maximum_type1") == 0) {
#line 85 "../src/game-config.vala"
			gcfg.maximum_type1 = val;
#line 86 "../src/game-config.vala"
			pflag |= (guint) 0x00000010;
#line 683 "game-config.c"
		}
#line 88 "../src/game-config.vala"
		_tmp36_ = key;
#line 88 "../src/game-config.vala"
		if (g_strcmp0 (_tmp36_, "maximum_type2") == 0) {
#line 89 "../src/game-config.vala"
			gcfg.maximum_type2 = val;
#line 90 "../src/game-config.vala"
			pflag |= (guint) 0x00000020;
#line 693 "game-config.c"
		}
#line 92 "../src/game-config.vala"
		_tmp37_ = key;
#line 92 "../src/game-config.vala"
		if (g_strcmp0 (_tmp37_, "score_type1") == 0) {
#line 93 "../src/game-config.vala"
			gcfg.score_type1 = val;
#line 94 "../src/game-config.vala"
			pflag |= (guint) 0x00000040;
#line 703 "game-config.c"
		}
#line 96 "../src/game-config.vala"
		_tmp38_ = key;
#line 96 "../src/game-config.vala"
		if (g_strcmp0 (_tmp38_, "score_type2") == 0) {
#line 97 "../src/game-config.vala"
			gcfg.score_type2 = val;
#line 98 "../src/game-config.vala"
			pflag |= (guint) 0x00000080;
#line 713 "game-config.c"
		}
#line 100 "../src/game-config.vala"
		_tmp39_ = key;
#line 100 "../src/game-config.vala"
		if (g_strcmp0 (_tmp39_, "score_type1_waiting") == 0) {
#line 101 "../src/game-config.vala"
			gcfg.score_type1_waiting = val;
#line 102 "../src/game-config.vala"
			pflag |= (guint) 0x00000100;
#line 723 "game-config.c"
		}
#line 104 "../src/game-config.vala"
		_tmp40_ = key;
#line 104 "../src/game-config.vala"
		if (g_strcmp0 (_tmp40_, "score_type2_waiting") == 0) {
#line 105 "../src/game-config.vala"
			gcfg.score_type2_waiting = val;
#line 106 "../src/game-config.vala"
			pflag |= (guint) 0x00000200;
#line 733 "game-config.c"
		}
#line 108 "../src/game-config.vala"
		_tmp41_ = key;
#line 108 "../src/game-config.vala"
		if (g_strcmp0 (_tmp41_, "score_type1_splatted") == 0) {
#line 109 "../src/game-config.vala"
			gcfg.score_type1_splatted = val;
#line 110 "../src/game-config.vala"
			pflag |= (guint) 0x00000400;
#line 743 "game-config.c"
		}
#line 112 "../src/game-config.vala"
		_tmp42_ = key;
#line 112 "../src/game-config.vala"
		if (g_strcmp0 (_tmp42_, "score_type2_splatted") == 0) {
#line 113 "../src/game-config.vala"
			gcfg.score_type2_splatted = val;
#line 114 "../src/game-config.vala"
			pflag |= (guint) 0x00000800;
#line 753 "game-config.c"
		}
#line 116 "../src/game-config.vala"
		_tmp43_ = key;
#line 116 "../src/game-config.vala"
		if (g_strcmp0 (_tmp43_, "num_robots_per_safe") == 0) {
#line 117 "../src/game-config.vala"
			gcfg.num_robots_per_safe = val;
#line 118 "../src/game-config.vala"
			pflag |= (guint) 0x00001000;
#line 763 "game-config.c"
		}
#line 120 "../src/game-config.vala"
		_tmp44_ = key;
#line 120 "../src/game-config.vala"
		if (g_strcmp0 (_tmp44_, "safe_score_boundary") == 0) {
#line 121 "../src/game-config.vala"
			gcfg.safe_score_boundary = val;
#line 122 "../src/game-config.vala"
			pflag |= (guint) 0x00002000;
#line 773 "game-config.c"
		}
#line 124 "../src/game-config.vala"
		_tmp45_ = key;
#line 124 "../src/game-config.vala"
		if (g_strcmp0 (_tmp45_, "max_safe_teleports") == 0) {
#line 125 "../src/game-config.vala"
			gcfg.max_safe_teleports = val;
#line 126 "../src/game-config.vala"
			pflag |= (guint) 0x00004000;
#line 783 "game-config.c"
		}
#line 128 "../src/game-config.vala"
		_tmp46_ = key;
#line 128 "../src/game-config.vala"
		if (g_strcmp0 (_tmp46_, "initial_safe_teleports") == 0) {
#line 129 "../src/game-config.vala"
			gcfg.initial_safe_teleports = val;
#line 130 "../src/game-config.vala"
			pflag |= (guint) 0x00008000;
#line 793 "game-config.c"
		}
#line 132 "../src/game-config.vala"
		_tmp47_ = key;
#line 132 "../src/game-config.vala"
		if (g_strcmp0 (_tmp47_, "free_safe_teleports") == 0) {
#line 133 "../src/game-config.vala"
			gcfg.free_safe_teleports = val;
#line 134 "../src/game-config.vala"
			pflag |= (guint) 0x00010000;
#line 803 "game-config.c"
		}
#line 136 "../src/game-config.vala"
		_tmp48_ = key;
#line 136 "../src/game-config.vala"
		if (g_strcmp0 (_tmp48_, "moveable_heaps") == 0) {
#line 137 "../src/game-config.vala"
			gcfg.moveable_heaps = val != 0;
#line 138 "../src/game-config.vala"
			pflag |= (guint) 0x00020000;
#line 813 "game-config.c"
		}
#line 60 "../src/game-config.vala"
		_g_free0 (key);
#line 60 "../src/game-config.vala"
		_g_match_info_unref0 (match_info);
#line 60 "../src/game-config.vala"
		_g_free0 (_tmp16_);
#line 821 "game-config.c"
	}
#line 143 "../src/game-config.vala"
	if (pflag != ((guint) 0x0003ffff)) {
#line 825 "game-config.c"
		GError* _tmp49_;
#line 144 "../src/game-config.vala"
		_tmp49_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, "Bad game config file.");
#line 144 "../src/game-config.vala"
		_inner_error0_ = _tmp49_;
#line 144 "../src/game-config.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../src/game-config.vala"
		_g_free0 (line);
#line 144 "../src/game-config.vala"
		_g_object_unref0 (dis);
#line 144 "../src/game-config.vala"
		_g_object_unref0 (_tmp12_);
#line 144 "../src/game-config.vala"
		_g_object_unref0 (file);
#line 144 "../src/game-config.vala"
		_g_regex_unref0 (line_regex);
#line 144 "../src/game-config.vala"
		game_config_destroy (&gcfg);
#line 144 "../src/game-config.vala"
		return;
#line 847 "game-config.c"
	}
#line 147 "../src/game-config.vala"
	*result = gcfg;
#line 147 "../src/game-config.vala"
	_g_free0 (line);
#line 147 "../src/game-config.vala"
	_g_object_unref0 (dis);
#line 147 "../src/game-config.vala"
	_g_object_unref0 (_tmp12_);
#line 147 "../src/game-config.vala"
	_g_object_unref0 (file);
#line 147 "../src/game-config.vala"
	_g_regex_unref0 (line_regex);
#line 147 "../src/game-config.vala"
	return;
#line 863 "game-config.c"
}

void
game_config_copy (const GameConfig* self,
                  GameConfig* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/game-config.vala"
	_tmp0_ = (*self).description;
#line 20 "../src/game-config.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 20 "../src/game-config.vala"
	_g_free0 ((*dest).description);
#line 20 "../src/game-config.vala"
	(*dest).description = _tmp1_;
#line 20 "../src/game-config.vala"
	(*dest).initial_type1 = (*self).initial_type1;
#line 20 "../src/game-config.vala"
	(*dest).initial_type2 = (*self).initial_type2;
#line 20 "../src/game-config.vala"
	(*dest).increment_type1 = (*self).increment_type1;
#line 20 "../src/game-config.vala"
	(*dest).increment_type2 = (*self).increment_type2;
#line 20 "../src/game-config.vala"
	(*dest).maximum_type1 = (*self).maximum_type1;
#line 20 "../src/game-config.vala"
	(*dest).maximum_type2 = (*self).maximum_type2;
#line 20 "../src/game-config.vala"
	(*dest).score_type1 = (*self).score_type1;
#line 20 "../src/game-config.vala"
	(*dest).score_type2 = (*self).score_type2;
#line 20 "../src/game-config.vala"
	(*dest).score_type1_waiting = (*self).score_type1_waiting;
#line 20 "../src/game-config.vala"
	(*dest).score_type2_waiting = (*self).score_type2_waiting;
#line 20 "../src/game-config.vala"
	(*dest).score_type1_splatted = (*self).score_type1_splatted;
#line 20 "../src/game-config.vala"
	(*dest).score_type2_splatted = (*self).score_type2_splatted;
#line 20 "../src/game-config.vala"
	(*dest).num_robots_per_safe = (*self).num_robots_per_safe;
#line 20 "../src/game-config.vala"
	(*dest).safe_score_boundary = (*self).safe_score_boundary;
#line 20 "../src/game-config.vala"
	(*dest).initial_safe_teleports = (*self).initial_safe_teleports;
#line 20 "../src/game-config.vala"
	(*dest).free_safe_teleports = (*self).free_safe_teleports;
#line 20 "../src/game-config.vala"
	(*dest).max_safe_teleports = (*self).max_safe_teleports;
#line 20 "../src/game-config.vala"
	(*dest).moveable_heaps = (*self).moveable_heaps;
#line 916 "game-config.c"
}

void
game_config_destroy (GameConfig* self)
{
#line 21 "../src/game-config.vala"
	_g_free0 ((*self).description);
#line 924 "game-config.c"
}

GameConfig*
game_config_dup (const GameConfig* self)
{
	GameConfig* dup;
#line 20 "../src/game-config.vala"
	dup = g_new0 (GameConfig, 1);
#line 20 "../src/game-config.vala"
	game_config_copy (self, dup);
#line 20 "../src/game-config.vala"
	return dup;
#line 937 "game-config.c"
}

void
game_config_free (GameConfig* self)
{
#line 20 "../src/game-config.vala"
	game_config_destroy (self);
#line 20 "../src/game-config.vala"
	g_free (self);
#line 947 "game-config.c"
}

static GType
game_config_get_type_once (void)
{
	GType game_config_type_id;
	game_config_type_id = g_boxed_type_register_static ("GameConfig", (GBoxedCopyFunc) game_config_dup, (GBoxedFreeFunc) game_config_free);
	return game_config_type_id;
}

GType
game_config_get_type (void)
{
	static volatile gsize game_config_type_id__once = 0;
	if (g_once_init_enter (&game_config_type_id__once)) {
		GType game_config_type_id;
		game_config_type_id = game_config_get_type_once ();
		g_once_init_leave (&game_config_type_id__once, game_config_type_id);
	}
	return game_config_type_id__once;
}

static inline gpointer
game_configs_get_instance_private (GameConfigs* self)
{
	return G_STRUCT_MEMBER_P (self, GameConfigs_private_offset);
}

GameConfigs*
game_configs_construct_load (GType object_type,
                             GError** error)
{
	GameConfigs* self = NULL;
	gchar* dname = NULL;
	gchar* _tmp0_;
	GDir* dir = NULL;
	const gchar* _tmp1_;
	GDir* _tmp2_;
	GeeArrayList* _tmp3_;
	gchar* filename = NULL;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GError* _inner_error0_ = NULL;
#line 154 "../src/game-config.vala"
	self = (GameConfigs*) g_type_create_instance (object_type);
#line 155 "../src/game-config.vala"
	_tmp0_ = g_build_filename (DATA_DIRECTORY, "games", NULL);
#line 155 "../src/game-config.vala"
	dname = _tmp0_;
#line 156 "../src/game-config.vala"
	_tmp1_ = dname;
#line 156 "../src/game-config.vala"
	_tmp2_ = g_dir_open (_tmp1_, (guint) 0, &_inner_error0_);
#line 156 "../src/game-config.vala"
	dir = _tmp2_;
#line 156 "../src/game-config.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/game-config.vala"
		g_propagate_error (error, _inner_error0_);
#line 156 "../src/game-config.vala"
		_g_free0 (dname);
#line 156 "../src/game-config.vala"
		_game_configs_unref0 (self);
#line 156 "../src/game-config.vala"
		return NULL;
#line 1014 "game-config.c"
	}
#line 157 "../src/game-config.vala"
	_tmp3_ = gee_array_list_new (TYPE_GAME_CONFIG, (GBoxedCopyFunc) game_config_dup, (GDestroyNotify) game_config_free, NULL, NULL, NULL);
#line 157 "../src/game-config.vala"
	_g_object_unref0 (self->priv->game_configs);
#line 157 "../src/game-config.vala"
	self->priv->game_configs = _tmp3_;
#line 159 "../src/game-config.vala"
	while (TRUE) {
#line 1024 "game-config.c"
		GDir* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* fullname = NULL;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 159 "../src/game-config.vala"
		_tmp4_ = dir;
#line 159 "../src/game-config.vala"
		_tmp5_ = g_dir_read_name (_tmp4_);
#line 159 "../src/game-config.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 159 "../src/game-config.vala"
		_g_free0 (filename);
#line 159 "../src/game-config.vala"
		filename = _tmp6_;
#line 159 "../src/game-config.vala"
		_tmp7_ = filename;
#line 159 "../src/game-config.vala"
		if (!(_tmp7_ != NULL)) {
#line 159 "../src/game-config.vala"
			break;
#line 1050 "game-config.c"
		}
#line 160 "../src/game-config.vala"
		_tmp8_ = filename;
#line 160 "../src/game-config.vala"
		if (!g_str_has_suffix (_tmp8_, ".cfg")) {
#line 161 "../src/game-config.vala"
			continue;
#line 1058 "game-config.c"
		}
#line 163 "../src/game-config.vala"
		_tmp9_ = dname;
#line 163 "../src/game-config.vala"
		_tmp10_ = filename;
#line 163 "../src/game-config.vala"
		_tmp11_ = g_build_filename (_tmp9_, _tmp10_, NULL);
#line 163 "../src/game-config.vala"
		fullname = _tmp11_;
#line 1068 "game-config.c"
		{
			GameConfig gcfg = {0};
			const gchar* _tmp12_;
			GameConfig _tmp13_ = {0};
			GeeArrayList* _tmp14_;
			GameConfig _tmp15_;
#line 165 "../src/game-config.vala"
			_tmp12_ = fullname;
#line 165 "../src/game-config.vala"
			game_config_from_file (_tmp12_, &_tmp13_, &_inner_error0_);
#line 165 "../src/game-config.vala"
			gcfg = _tmp13_;
#line 165 "../src/game-config.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "game-config.c"
				goto __catch0_g_error;
			}
#line 166 "../src/game-config.vala"
			_tmp14_ = self->priv->game_configs;
#line 166 "../src/game-config.vala"
			_tmp15_ = gcfg;
#line 166 "../src/game-config.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, &_tmp15_);
#line 164 "../src/game-config.vala"
			game_config_destroy (&gcfg);
#line 1094 "game-config.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 164 "../src/game-config.vala"
			e = _inner_error0_;
#line 164 "../src/game-config.vala"
			_inner_error0_ = NULL;
#line 168 "../src/game-config.vala"
			_tmp16_ = e;
#line 168 "../src/game-config.vala"
			_tmp17_ = _tmp16_->message;
#line 168 "../src/game-config.vala"
			g_warning ("game-config.vala:168: %s", _tmp17_);
#line 164 "../src/game-config.vala"
			_g_error_free0 (e);
#line 1114 "game-config.c"
		}
		__finally0:
#line 164 "../src/game-config.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/game-config.vala"
			g_propagate_error (error, _inner_error0_);
#line 164 "../src/game-config.vala"
			_g_free0 (fullname);
#line 164 "../src/game-config.vala"
			_g_free0 (filename);
#line 164 "../src/game-config.vala"
			_g_dir_close0 (dir);
#line 164 "../src/game-config.vala"
			_g_free0 (dname);
#line 164 "../src/game-config.vala"
			_game_configs_unref0 (self);
#line 164 "../src/game-config.vala"
			return NULL;
#line 1133 "game-config.c"
		}
#line 159 "../src/game-config.vala"
		_g_free0 (fullname);
#line 1137 "game-config.c"
	}
#line 172 "../src/game-config.vala"
	_tmp18_ = self->priv->game_configs;
#line 172 "../src/game-config.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 172 "../src/game-config.vala"
	_tmp20_ = _tmp19_;
#line 172 "../src/game-config.vala"
	if (_tmp20_ == 0) {
#line 1147 "game-config.c"
		GError* _tmp21_;
#line 173 "../src/game-config.vala"
		_tmp21_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_NOENT, "No game config was found.");
#line 173 "../src/game-config.vala"
		_inner_error0_ = _tmp21_;
#line 173 "../src/game-config.vala"
		g_propagate_error (error, _inner_error0_);
#line 173 "../src/game-config.vala"
		_g_free0 (filename);
#line 173 "../src/game-config.vala"
		_g_dir_close0 (dir);
#line 173 "../src/game-config.vala"
		_g_free0 (dname);
#line 173 "../src/game-config.vala"
		_game_configs_unref0 (self);
#line 173 "../src/game-config.vala"
		return NULL;
#line 1165 "game-config.c"
	}
#line 154 "../src/game-config.vala"
	_g_free0 (filename);
#line 154 "../src/game-config.vala"
	_g_dir_close0 (dir);
#line 154 "../src/game-config.vala"
	_g_free0 (dname);
#line 154 "../src/game-config.vala"
	return self;
#line 1175 "game-config.c"
}

GameConfigs*
game_configs_new_load (GError** error)
{
#line 154 "../src/game-config.vala"
	return game_configs_construct_load (TYPE_GAME_CONFIGS, error);
#line 1183 "game-config.c"
}

guint
game_configs_count (GameConfigs* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result;
#line 177 "../src/game-config.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 178 "../src/game-config.vala"
	_tmp0_ = self->priv->game_configs;
#line 178 "../src/game-config.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 178 "../src/game-config.vala"
	_tmp2_ = _tmp1_;
#line 178 "../src/game-config.vala"
	result = (guint) _tmp2_;
#line 178 "../src/game-config.vala"
	return result;
#line 1205 "game-config.c"
}

GameConfig*
game_configs_get (GameConfigs* self,
                  guint n)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GameConfig* result;
#line 181 "../src/game-config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 182 "../src/game-config.vala"
	_tmp0_ = self->priv->game_configs;
#line 182 "../src/game-config.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 182 "../src/game-config.vala"
	_tmp2_ = _tmp1_;
#line 182 "../src/game-config.vala"
	if (n < ((guint) _tmp2_)) {
#line 1226 "game-config.c"
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
#line 183 "../src/game-config.vala"
		_tmp3_ = self->priv->game_configs;
#line 183 "../src/game-config.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, (gint) n);
#line 183 "../src/game-config.vala"
		result = (GameConfig*) _tmp4_;
#line 183 "../src/game-config.vala"
		return result;
#line 1237 "game-config.c"
	} else {
#line 185 "../src/game-config.vala"
		result = NULL;
#line 185 "../src/game-config.vala"
		return result;
#line 1243 "game-config.c"
	}
}

gchar*
game_configs_get_name (GameConfigs* self,
                       guint n)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* result;
#line 188 "../src/game-config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../src/game-config.vala"
	_tmp0_ = self->priv->game_configs;
#line 189 "../src/game-config.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 189 "../src/game-config.vala"
	_tmp2_ = _tmp1_;
#line 189 "../src/game-config.vala"
	if (n < ((guint) _tmp2_)) {
#line 1265 "game-config.c"
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
		GameConfig* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 190 "../src/game-config.vala"
		_tmp3_ = self->priv->game_configs;
#line 190 "../src/game-config.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, (gint) n);
#line 190 "../src/game-config.vala"
		_tmp5_ = (GameConfig*) _tmp4_;
#line 190 "../src/game-config.vala"
		_tmp6_ = (*_tmp5_).description;
#line 190 "../src/game-config.vala"
		_tmp7_ = string_replace (_tmp6_, "_", " ");
#line 190 "../src/game-config.vala"
		_tmp8_ = _tmp7_;
#line 190 "../src/game-config.vala"
		_game_config_free0 (_tmp5_);
#line 190 "../src/game-config.vala"
		result = _tmp8_;
#line 190 "../src/game-config.vala"
		return result;
#line 1290 "game-config.c"
	} else {
#line 192 "../src/game-config.vala"
		result = NULL;
#line 192 "../src/game-config.vala"
		return result;
#line 1296 "game-config.c"
	}
}

GameConfig*
game_configs_find_by_name (GameConfigs* self,
                           const gchar* name)
{
	GameConfig* result;
#line 195 "../src/game-config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 195 "../src/game-config.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1309 "game-config.c"
	{
		gint i = 0;
#line 196 "../src/game-config.vala"
		i = 0;
#line 1314 "game-config.c"
		{
			gboolean _tmp0_ = FALSE;
#line 196 "../src/game-config.vala"
			_tmp0_ = TRUE;
#line 196 "../src/game-config.vala"
			while (TRUE) {
#line 1321 "game-config.c"
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gboolean _tmp5_ = FALSE;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				GameConfig* _tmp8_;
				const gchar* _tmp9_;
				gboolean _tmp10_;
#line 196 "../src/game-config.vala"
				if (!_tmp0_) {
#line 1333 "game-config.c"
					gint _tmp1_;
#line 196 "../src/game-config.vala"
					i = i + 1;
#line 196 "../src/game-config.vala"
					_tmp1_ = i;
#line 1339 "game-config.c"
				}
#line 196 "../src/game-config.vala"
				_tmp0_ = FALSE;
#line 196 "../src/game-config.vala"
				_tmp2_ = self->priv->game_configs;
#line 196 "../src/game-config.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 196 "../src/game-config.vala"
				_tmp4_ = _tmp3_;
#line 196 "../src/game-config.vala"
				if (!(i < _tmp4_)) {
#line 196 "../src/game-config.vala"
					break;
#line 1353 "game-config.c"
				}
#line 197 "../src/game-config.vala"
				_tmp6_ = self->priv->game_configs;
#line 197 "../src/game-config.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, i);
#line 197 "../src/game-config.vala"
				_tmp8_ = (GameConfig*) _tmp7_;
#line 197 "../src/game-config.vala"
				_tmp9_ = (*_tmp8_).description;
#line 197 "../src/game-config.vala"
				_tmp10_ = g_strcmp0 (_tmp9_, name) == 0;
#line 197 "../src/game-config.vala"
				_game_config_free0 (_tmp8_);
#line 197 "../src/game-config.vala"
				if (_tmp10_) {
#line 197 "../src/game-config.vala"
					_tmp5_ = TRUE;
#line 1371 "game-config.c"
				} else {
					GeeArrayList* _tmp11_;
					gpointer _tmp12_;
					GameConfig* _tmp13_;
					GameConfig _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
#line 197 "../src/game-config.vala"
					_tmp11_ = self->priv->game_configs;
#line 197 "../src/game-config.vala"
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, i);
#line 197 "../src/game-config.vala"
					_tmp13_ = (GameConfig*) _tmp12_;
#line 197 "../src/game-config.vala"
					_tmp14_ = *_tmp13_;
#line 197 "../src/game-config.vala"
					_tmp15_ = game_config_name (&_tmp14_);
#line 197 "../src/game-config.vala"
					_tmp16_ = _tmp15_;
#line 197 "../src/game-config.vala"
					_tmp5_ = g_strcmp0 (_tmp16_, name) == 0;
#line 197 "../src/game-config.vala"
					_g_free0 (_tmp16_);
#line 197 "../src/game-config.vala"
					_game_config_free0 (_tmp13_);
#line 1397 "game-config.c"
				}
#line 197 "../src/game-config.vala"
				if (_tmp5_) {
#line 1401 "game-config.c"
					GeeArrayList* _tmp17_;
					gpointer _tmp18_;
#line 198 "../src/game-config.vala"
					_tmp17_ = self->priv->game_configs;
#line 198 "../src/game-config.vala"
					_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, i);
#line 198 "../src/game-config.vala"
					result = (GameConfig*) _tmp18_;
#line 198 "../src/game-config.vala"
					return result;
#line 1412 "game-config.c"
				}
			}
		}
	}
#line 201 "../src/game-config.vala"
	result = NULL;
#line 201 "../src/game-config.vala"
	return result;
#line 1421 "game-config.c"
}

GameConfigs*
game_configs_construct (GType object_type)
{
	GameConfigs* self = NULL;
#line 151 "../src/game-config.vala"
	self = (GameConfigs*) g_type_create_instance (object_type);
#line 151 "../src/game-config.vala"
	return self;
#line 1432 "game-config.c"
}

GameConfigs*
game_configs_new (void)
{
#line 151 "../src/game-config.vala"
	return game_configs_construct (TYPE_GAME_CONFIGS);
#line 1440 "game-config.c"
}

static void
value_game_configs_init (GValue* value)
{
#line 151 "../src/game-config.vala"
	value->data[0].v_pointer = NULL;
#line 1448 "game-config.c"
}

static void
value_game_configs_free_value (GValue* value)
{
#line 151 "../src/game-config.vala"
	if (value->data[0].v_pointer) {
#line 151 "../src/game-config.vala"
		game_configs_unref (value->data[0].v_pointer);
#line 1458 "game-config.c"
	}
}

static void
value_game_configs_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 151 "../src/game-config.vala"
	if (src_value->data[0].v_pointer) {
#line 151 "../src/game-config.vala"
		dest_value->data[0].v_pointer = game_configs_ref (src_value->data[0].v_pointer);
#line 1470 "game-config.c"
	} else {
#line 151 "../src/game-config.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1474 "game-config.c"
	}
}

static gpointer
value_game_configs_peek_pointer (const GValue* value)
{
#line 151 "../src/game-config.vala"
	return value->data[0].v_pointer;
#line 1483 "game-config.c"
}

static gchar*
value_game_configs_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 151 "../src/game-config.vala"
	if (collect_values[0].v_pointer) {
#line 1494 "game-config.c"
		GameConfigs * object;
		object = collect_values[0].v_pointer;
#line 151 "../src/game-config.vala"
		if (object->parent_instance.g_class == NULL) {
#line 151 "../src/game-config.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1501 "game-config.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 151 "../src/game-config.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1505 "game-config.c"
		}
#line 151 "../src/game-config.vala"
		value->data[0].v_pointer = game_configs_ref (object);
#line 1509 "game-config.c"
	} else {
#line 151 "../src/game-config.vala"
		value->data[0].v_pointer = NULL;
#line 1513 "game-config.c"
	}
#line 151 "../src/game-config.vala"
	return NULL;
#line 1517 "game-config.c"
}

static gchar*
value_game_configs_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	GameConfigs ** object_p;
	object_p = collect_values[0].v_pointer;
#line 151 "../src/game-config.vala"
	if (!object_p) {
#line 151 "../src/game-config.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1532 "game-config.c"
	}
#line 151 "../src/game-config.vala"
	if (!value->data[0].v_pointer) {
#line 151 "../src/game-config.vala"
		*object_p = NULL;
#line 1538 "game-config.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 151 "../src/game-config.vala"
		*object_p = value->data[0].v_pointer;
#line 1542 "game-config.c"
	} else {
#line 151 "../src/game-config.vala"
		*object_p = game_configs_ref (value->data[0].v_pointer);
#line 1546 "game-config.c"
	}
#line 151 "../src/game-config.vala"
	return NULL;
#line 1550 "game-config.c"
}

GParamSpec*
param_spec_game_configs (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecGameConfigs* spec;
#line 151 "../src/game-config.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_GAME_CONFIGS), NULL);
#line 151 "../src/game-config.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 151 "../src/game-config.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 151 "../src/game-config.vala"
	return G_PARAM_SPEC (spec);
#line 1569 "game-config.c"
}

gpointer
value_get_game_configs (const GValue* value)
{
#line 151 "../src/game-config.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME_CONFIGS), NULL);
#line 151 "../src/game-config.vala"
	return value->data[0].v_pointer;
#line 1579 "game-config.c"
}

void
value_set_game_configs (GValue* value,
                        gpointer v_object)
{
	GameConfigs * old;
#line 151 "../src/game-config.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME_CONFIGS));
#line 151 "../src/game-config.vala"
	old = value->data[0].v_pointer;
#line 151 "../src/game-config.vala"
	if (v_object) {
#line 151 "../src/game-config.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME_CONFIGS));
#line 151 "../src/game-config.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 151 "../src/game-config.vala"
		value->data[0].v_pointer = v_object;
#line 151 "../src/game-config.vala"
		game_configs_ref (value->data[0].v_pointer);
#line 1601 "game-config.c"
	} else {
#line 151 "../src/game-config.vala"
		value->data[0].v_pointer = NULL;
#line 1605 "game-config.c"
	}
#line 151 "../src/game-config.vala"
	if (old) {
#line 151 "../src/game-config.vala"
		game_configs_unref (old);
#line 1611 "game-config.c"
	}
}

void
value_take_game_configs (GValue* value,
                         gpointer v_object)
{
	GameConfigs * old;
#line 151 "../src/game-config.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME_CONFIGS));
#line 151 "../src/game-config.vala"
	old = value->data[0].v_pointer;
#line 151 "../src/game-config.vala"
	if (v_object) {
#line 151 "../src/game-config.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME_CONFIGS));
#line 151 "../src/game-config.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 151 "../src/game-config.vala"
		value->data[0].v_pointer = v_object;
#line 1632 "game-config.c"
	} else {
#line 151 "../src/game-config.vala"
		value->data[0].v_pointer = NULL;
#line 1636 "game-config.c"
	}
#line 151 "../src/game-config.vala"
	if (old) {
#line 151 "../src/game-config.vala"
		game_configs_unref (old);
#line 1642 "game-config.c"
	}
}

static void
game_configs_class_init (GameConfigsClass * klass,
                         gpointer klass_data)
{
#line 151 "../src/game-config.vala"
	game_configs_parent_class = g_type_class_peek_parent (klass);
#line 151 "../src/game-config.vala"
	((GameConfigsClass *) klass)->finalize = game_configs_finalize;
#line 151 "../src/game-config.vala"
	g_type_class_adjust_private_offset (klass, &GameConfigs_private_offset);
#line 1656 "game-config.c"
}

static void
game_configs_instance_init (GameConfigs * self,
                            gpointer klass)
{
#line 151 "../src/game-config.vala"
	self->priv = game_configs_get_instance_private (self);
#line 151 "../src/game-config.vala"
	self->ref_count = 1;
#line 1667 "game-config.c"
}

static void
game_configs_finalize (GameConfigs * obj)
{
	GameConfigs * self;
#line 151 "../src/game-config.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_CONFIGS, GameConfigs);
#line 151 "../src/game-config.vala"
	g_signal_handlers_destroy (self);
#line 152 "../src/game-config.vala"
	_g_object_unref0 (self->priv->game_configs);
#line 1680 "game-config.c"
}

static GType
game_configs_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_game_configs_init, value_game_configs_free_value, value_game_configs_copy_value, value_game_configs_peek_pointer, "p", value_game_configs_collect_value, "p", value_game_configs_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameConfigsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_configs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameConfigs), 0, (GInstanceInitFunc) game_configs_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_configs_type_id;
	game_configs_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameConfigs", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GameConfigs_private_offset = g_type_add_instance_private (game_configs_type_id, sizeof (GameConfigsPrivate));
	return game_configs_type_id;
}

GType
game_configs_get_type (void)
{
	static volatile gsize game_configs_type_id__once = 0;
	if (g_once_init_enter (&game_configs_type_id__once)) {
		GType game_configs_type_id;
		game_configs_type_id = game_configs_get_type_once ();
		g_once_init_leave (&game_configs_type_id__once, game_configs_type_id);
	}
	return game_configs_type_id__once;
}

gpointer
game_configs_ref (gpointer instance)
{
	GameConfigs * self;
	self = instance;
#line 151 "../src/game-config.vala"
	g_atomic_int_inc (&self->ref_count);
#line 151 "../src/game-config.vala"
	return instance;
#line 1716 "game-config.c"
}

void
game_configs_unref (gpointer instance)
{
	GameConfigs * self;
	self = instance;
#line 151 "../src/game-config.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 151 "../src/game-config.vala"
		GAME_CONFIGS_GET_CLASS (self)->finalize (self);
#line 151 "../src/game-config.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1730 "game-config.c"
	}
}

