/* properties.c generated by valac 0.56.9, the Vala compiler
 * generated from properties.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#define PROPERTIES_KEY_BACKGROUND_COLOR "background-color"
#define PROPERTIES_KEY_CONFIGURATION "configuration"
#define PROPERTIES_KEY_ENABLE_SOUND "enable-sound"
#define PROPERTIES_KEY_SAFE_MOVES "use-safe-moves"
#define PROPERTIES_KEY_SHOW_TOOLBAR "show-toolbar"
#define PROPERTIES_KEY_SUPER_SAFE_MOVES "use-super-safe-moves"
#define PROPERTIES_KEY_THEME "theme"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PROPERTIES (properties_get_type ())
#define PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTIES, Properties))
#define PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTIES, PropertiesClass))
#define IS_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTIES))
#define IS_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTIES))
#define PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTIES, PropertiesClass))

typedef struct _Properties Properties;
typedef struct _PropertiesClass PropertiesClass;
typedef struct _PropertiesPrivate PropertiesPrivate;

#define PROPERTIES_TYPE_KEYS (properties_keys_get_type ())
#define PROPERTIES_KEYS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PROPERTIES_TYPE_KEYS, PropertiesKeys))
#define PROPERTIES_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PROPERTIES_TYPE_KEYS, PropertiesKeysClass))
#define PROPERTIES_IS_KEYS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PROPERTIES_TYPE_KEYS))
#define PROPERTIES_IS_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PROPERTIES_TYPE_KEYS))
#define PROPERTIES_KEYS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PROPERTIES_TYPE_KEYS, PropertiesKeysClass))

typedef struct _PropertiesKeys PropertiesKeys;
typedef struct _PropertiesKeysClass PropertiesKeysClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _properties_keys_unref0(var) ((var == NULL) ? NULL : (var = (properties_keys_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PropertiesKeysPrivate PropertiesKeysPrivate;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _PropertiesParamSpecKeys PropertiesParamSpecKeys;
typedef struct _ParamSpecProperties ParamSpecProperties;
enum  {
	PROPERTIES_CHANGED_SIGNAL,
	PROPERTIES_NUM_SIGNALS
};
static guint properties_signals[PROPERTIES_NUM_SIGNALS] = {0};

struct _Properties {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PropertiesPrivate * priv;
};

struct _PropertiesClass {
	GTypeClass parent_class;
	void (*finalize) (Properties *self);
};

struct _PropertiesPrivate {
	GSettings* settings;
	PropertiesKeys* _keys;
	gulong notify_handler_id;
};

struct _PropertiesKeys {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PropertiesKeysPrivate * priv;
};

struct _PropertiesKeysClass {
	GTypeClass parent_class;
	void (*finalize) (PropertiesKeys *self);
};

struct _PropertiesKeysPrivate {
	GSettings* settings;
};

struct _PropertiesParamSpecKeys {
	GParamSpec parent_instance;
};

struct _ParamSpecProperties {
	GParamSpec parent_instance;
};

static gint Properties_private_offset;
static gpointer properties_parent_class = NULL;
static gint PropertiesKeys_private_offset;
static gpointer properties_keys_parent_class = NULL;

VALA_EXTERN gpointer properties_ref (gpointer instance);
VALA_EXTERN void properties_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_properties (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_properties (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_properties (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_properties (const GValue* value);
VALA_EXTERN GType properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Properties, properties_unref)
VALA_EXTERN gpointer properties_keys_ref (gpointer instance);
VALA_EXTERN void properties_keys_unref (gpointer instance);
VALA_EXTERN GParamSpec* properties_param_spec_keys (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void properties_value_set_keys (GValue* value,
                                gpointer v_object);
VALA_EXTERN void properties_value_take_keys (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer properties_value_get_keys (const GValue* value);
VALA_EXTERN GType properties_keys_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertiesKeys, properties_keys_unref)
VALA_EXTERN Properties* properties_new (GSettings* settings);
VALA_EXTERN Properties* properties_construct (GType object_type,
                                  GSettings* settings);
VALA_EXTERN PropertiesKeys* properties_keys_new (GSettings* settings);
VALA_EXTERN PropertiesKeys* properties_keys_construct (GType object_type,
                                           GSettings* settings);
static void __lambda6_ (Properties* self);
static void ___lambda6__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
VALA_EXTERN gboolean properties_get_safe_moves (Properties* self);
VALA_EXTERN void properties_set_safe_moves (Properties* self,
                                gboolean value);
VALA_EXTERN gboolean properties_get_super_safe_moves (Properties* self);
VALA_EXTERN void properties_set_super_safe_moves (Properties* self,
                                      gboolean value);
VALA_EXTERN gboolean properties_get_sound (Properties* self);
VALA_EXTERN void properties_set_sound (Properties* self,
                           gboolean value);
VALA_EXTERN gboolean properties_get_show_toolbar (Properties* self);
VALA_EXTERN void properties_set_show_toolbar (Properties* self,
                                  gboolean value);
VALA_EXTERN void properties_get_bgcolour (Properties* self,
                              GdkRGBA * result);
VALA_EXTERN void string_to_rgba (const gchar* color,
                     GdkRGBA* result);
VALA_EXTERN void properties_set_bgcolour (Properties* self,
                              GdkRGBA * value);
VALA_EXTERN gchar* rgba_to_string (GdkRGBA* color);
VALA_EXTERN gchar* properties_get_selected_config (Properties* self);
VALA_EXTERN void properties_set_selected_config (Properties* self,
                                     const gchar* value);
VALA_EXTERN PropertiesKeys* properties_get_keys (Properties* self);
VALA_EXTERN gchar* properties_get_theme (Properties* self);
VALA_EXTERN void properties_set_theme (Properties* self,
                           const gchar* value);
VALA_EXTERN guint properties_keys_get (PropertiesKeys* self,
                           guint index);
VALA_EXTERN gint properties_keys_get_size (PropertiesKeys* self);
VALA_EXTERN void properties_keys_set (PropertiesKeys* self,
                          guint index,
                          guint keyval);
VALA_EXTERN guint properties_keys_get_default (PropertiesKeys* self,
                                   guint index);
VALA_EXTERN void properties_keys_reset (PropertiesKeys* self,
                            guint index);
VALA_EXTERN void properties_keys_reset_all (PropertiesKeys* self);
static void properties_keys_finalize (PropertiesKeys * obj);
static GType properties_keys_get_type_once (void);
static void properties_finalize (Properties * obj);
static GType properties_get_type_once (void);

static inline gpointer
properties_get_instance_private (Properties* self)
{
	return G_STRUCT_MEMBER_P (self, Properties_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 154 "../src/properties.vala"
	return self ? g_object_ref (self) : NULL;
#line 218 "properties.c"
}

static void
__lambda6_ (Properties* self)
{
#line 156 "../src/properties.vala"
	g_signal_emit (self, properties_signals[PROPERTIES_CHANGED_SIGNAL], 0);
#line 226 "properties.c"
}

static void
___lambda6__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 156 "../src/properties.vala"
	__lambda6_ ((Properties*) self);
#line 236 "properties.c"
}

Properties*
properties_construct (GType object_type,
                      GSettings* settings)
{
	Properties* self = NULL;
	GSettings* _tmp0_;
	PropertiesKeys* _tmp1_;
	gulong _tmp2_;
#line 153 "../src/properties.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 153 "../src/properties.vala"
	self = (Properties*) g_type_create_instance (object_type);
#line 154 "../src/properties.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 154 "../src/properties.vala"
	_g_object_unref0 (self->priv->settings);
#line 154 "../src/properties.vala"
	self->priv->settings = _tmp0_;
#line 155 "../src/properties.vala"
	_tmp1_ = properties_keys_new (settings);
#line 155 "../src/properties.vala"
	_properties_keys_unref0 (self->priv->_keys);
#line 155 "../src/properties.vala"
	self->priv->_keys = _tmp1_;
#line 156 "../src/properties.vala"
	_tmp2_ = g_signal_connect (settings, "changed", (GCallback) ___lambda6__g_settings_changed, self);
#line 156 "../src/properties.vala"
	self->priv->notify_handler_id = _tmp2_;
#line 153 "../src/properties.vala"
	return self;
#line 269 "properties.c"
}

Properties*
properties_new (GSettings* settings)
{
#line 153 "../src/properties.vala"
	return properties_construct (TYPE_PROPERTIES, settings);
#line 277 "properties.c"
}

gboolean
properties_get_safe_moves (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 79 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 80 "../src/properties.vala"
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_SAFE_MOVES);
#line 80 "../src/properties.vala"
	return result;
#line 293 "properties.c"
}

void
properties_set_safe_moves (Properties* self,
                           gboolean value)
{
	GSettings* _tmp0_;
#line 82 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 83 "../src/properties.vala"
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_SAFE_MOVES, value);
#line 307 "properties.c"
}

gboolean
properties_get_super_safe_moves (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 88 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 89 "../src/properties.vala"
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_SUPER_SAFE_MOVES);
#line 89 "../src/properties.vala"
	return result;
#line 323 "properties.c"
}

void
properties_set_super_safe_moves (Properties* self,
                                 gboolean value)
{
	GSettings* _tmp0_;
#line 91 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 92 "../src/properties.vala"
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_SUPER_SAFE_MOVES, value);
#line 337 "properties.c"
}

gboolean
properties_get_sound (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 97 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 98 "../src/properties.vala"
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_ENABLE_SOUND);
#line 98 "../src/properties.vala"
	return result;
#line 353 "properties.c"
}

void
properties_set_sound (Properties* self,
                      gboolean value)
{
	GSettings* _tmp0_;
#line 100 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 101 "../src/properties.vala"
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_ENABLE_SOUND, value);
#line 367 "properties.c"
}

gboolean
properties_get_show_toolbar (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 106 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 107 "../src/properties.vala"
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_SHOW_TOOLBAR);
#line 107 "../src/properties.vala"
	return result;
#line 383 "properties.c"
}

void
properties_set_show_toolbar (Properties* self,
                             gboolean value)
{
	GSettings* _tmp0_;
#line 109 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 110 "../src/properties.vala"
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_SHOW_TOOLBAR, value);
#line 397 "properties.c"
}

void
properties_get_bgcolour (Properties* self,
                         GdkRGBA * result)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_;
#line 115 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 116 "../src/properties.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, PROPERTIES_KEY_BACKGROUND_COLOR);
#line 116 "../src/properties.vala"
	_tmp2_ = _tmp1_;
#line 116 "../src/properties.vala"
	string_to_rgba (_tmp2_, &_tmp3_);
#line 116 "../src/properties.vala"
	_tmp4_ = _tmp3_;
#line 116 "../src/properties.vala"
	_g_free0 (_tmp2_);
#line 116 "../src/properties.vala"
	*result = _tmp4_;
#line 116 "../src/properties.vala"
	return;
#line 427 "properties.c"
}

void
properties_set_bgcolour (Properties* self,
                         GdkRGBA * value)
{
	GSettings* _tmp0_;
	GdkRGBA _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 118 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 119 "../src/properties.vala"
	_tmp1_ = *value;
#line 119 "../src/properties.vala"
	_tmp2_ = rgba_to_string (&_tmp1_);
#line 119 "../src/properties.vala"
	_tmp3_ = _tmp2_;
#line 119 "../src/properties.vala"
	g_settings_set_string (_tmp0_, PROPERTIES_KEY_BACKGROUND_COLOR, _tmp3_);
#line 119 "../src/properties.vala"
	_g_free0 (_tmp3_);
#line 452 "properties.c"
}

gchar*
properties_get_selected_config (Properties* self)
{
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
#line 124 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 125 "../src/properties.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, PROPERTIES_KEY_CONFIGURATION);
#line 125 "../src/properties.vala"
	result = _tmp1_;
#line 125 "../src/properties.vala"
	return result;
#line 471 "properties.c"
}

void
properties_set_selected_config (Properties* self,
                                const gchar* value)
{
	GSettings* _tmp0_;
#line 127 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 128 "../src/properties.vala"
	g_settings_set_string (_tmp0_, PROPERTIES_KEY_CONFIGURATION, value);
#line 485 "properties.c"
}

PropertiesKeys*
properties_get_keys (Properties* self)
{
	PropertiesKeys* result;
	PropertiesKeys* _tmp0_;
#line 133 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../src/properties.vala"
	_tmp0_ = self->priv->_keys;
#line 134 "../src/properties.vala"
	result = _tmp0_;
#line 134 "../src/properties.vala"
	return result;
#line 501 "properties.c"
}

gchar*
properties_get_theme (Properties* self)
{
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
#line 139 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 140 "../src/properties.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, PROPERTIES_KEY_THEME);
#line 140 "../src/properties.vala"
	result = _tmp1_;
#line 140 "../src/properties.vala"
	return result;
#line 520 "properties.c"
}

void
properties_set_theme (Properties* self,
                      const gchar* value)
{
	GSettings* _tmp0_;
#line 142 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 143 "../src/properties.vala"
	g_settings_set_string (_tmp0_, PROPERTIES_KEY_THEME, value);
#line 534 "properties.c"
}

static inline gpointer
properties_keys_get_instance_private (PropertiesKeys* self)
{
	return G_STRUCT_MEMBER_P (self, PropertiesKeys_private_offset);
}

PropertiesKeys*
properties_keys_construct (GType object_type,
                           GSettings* settings)
{
	PropertiesKeys* self = NULL;
	GSettings* _tmp0_;
#line 32 "../src/properties.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 32 "../src/properties.vala"
	self = (PropertiesKeys*) g_type_create_instance (object_type);
#line 33 "../src/properties.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 33 "../src/properties.vala"
	_g_object_unref0 (self->priv->settings);
#line 33 "../src/properties.vala"
	self->priv->settings = _tmp0_;
#line 32 "../src/properties.vala"
	return self;
#line 561 "properties.c"
}

PropertiesKeys*
properties_keys_new (GSettings* settings)
{
#line 32 "../src/properties.vala"
	return properties_keys_construct (PROPERTIES_TYPE_KEYS, settings);
#line 569 "properties.c"
}

guint
properties_keys_get (PropertiesKeys* self,
                     guint index)
{
	gint _tmp0_;
	gint _tmp1_;
	guint result;
#line 40 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 41 "../src/properties.vala"
	_tmp0_ = properties_keys_get_size (self);
#line 41 "../src/properties.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/properties.vala"
	if (index < ((guint) _tmp1_)) {
#line 587 "properties.c"
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		guint _tmp5_;
#line 42 "../src/properties.vala"
		_tmp2_ = self->priv->settings;
#line 42 "../src/properties.vala"
		_tmp3_ = g_strdup_printf ("key%02u", index);
#line 42 "../src/properties.vala"
		_tmp4_ = _tmp3_;
#line 42 "../src/properties.vala"
		_tmp5_ = (guint) g_settings_get_int (_tmp2_, _tmp4_);
#line 42 "../src/properties.vala"
		_g_free0 (_tmp4_);
#line 42 "../src/properties.vala"
		result = _tmp5_;
#line 42 "../src/properties.vala"
		return result;
#line 606 "properties.c"
	} else {
#line 44 "../src/properties.vala"
		result = (guint) 0;
#line 44 "../src/properties.vala"
		return result;
#line 612 "properties.c"
	}
}

void
properties_keys_set (PropertiesKeys* self,
                     guint index,
                     guint keyval)
{
	gint _tmp0_;
	gint _tmp1_;
#line 48 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/properties.vala"
	_tmp0_ = properties_keys_get_size (self);
#line 49 "../src/properties.vala"
	_tmp1_ = _tmp0_;
#line 49 "../src/properties.vala"
	if (index < ((guint) _tmp1_)) {
#line 631 "properties.c"
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 50 "../src/properties.vala"
		_tmp2_ = self->priv->settings;
#line 50 "../src/properties.vala"
		_tmp3_ = g_strdup_printf ("key%02u", index);
#line 50 "../src/properties.vala"
		_tmp4_ = _tmp3_;
#line 50 "../src/properties.vala"
		g_settings_set_int (_tmp2_, _tmp4_, (gint) keyval);
#line 50 "../src/properties.vala"
		_g_free0 (_tmp4_);
#line 645 "properties.c"
	}
}

guint
properties_keys_get_default (PropertiesKeys* self,
                             guint index)
{
	gint _tmp0_;
	gint _tmp1_;
	guint result;
#line 54 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/properties.vala"
	_tmp0_ = properties_keys_get_size (self);
#line 55 "../src/properties.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/properties.vala"
	if (index < ((guint) _tmp1_)) {
#line 664 "properties.c"
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		guint _tmp7_;
#line 56 "../src/properties.vala"
		_tmp2_ = self->priv->settings;
#line 56 "../src/properties.vala"
		_tmp3_ = g_strdup_printf ("key%02u", index);
#line 56 "../src/properties.vala"
		_tmp4_ = _tmp3_;
#line 56 "../src/properties.vala"
		_tmp5_ = g_settings_get_default_value (_tmp2_, _tmp4_);
#line 56 "../src/properties.vala"
		_tmp6_ = _tmp5_;
#line 56 "../src/properties.vala"
		_tmp7_ = (guint) g_variant_get_int32 (_tmp6_);
#line 56 "../src/properties.vala"
		_g_variant_unref0 (_tmp6_);
#line 56 "../src/properties.vala"
		_g_free0 (_tmp4_);
#line 56 "../src/properties.vala"
		result = _tmp7_;
#line 56 "../src/properties.vala"
		return result;
#line 691 "properties.c"
	} else {
#line 60 "../src/properties.vala"
		result = (guint) 0;
#line 60 "../src/properties.vala"
		return result;
#line 697 "properties.c"
	}
}

void
properties_keys_reset (PropertiesKeys* self,
                       guint index)
{
	gint _tmp0_;
	gint _tmp1_;
#line 64 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/properties.vala"
	_tmp0_ = properties_keys_get_size (self);
#line 65 "../src/properties.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/properties.vala"
	if (index < ((guint) _tmp1_)) {
#line 715 "properties.c"
		gchar* key = NULL;
		gchar* _tmp2_;
		GSettings* _tmp3_;
		const gchar* _tmp4_;
#line 66 "../src/properties.vala"
		_tmp2_ = g_strdup_printf ("key%02u", index);
#line 66 "../src/properties.vala"
		key = _tmp2_;
#line 67 "../src/properties.vala"
		_tmp3_ = self->priv->settings;
#line 67 "../src/properties.vala"
		_tmp4_ = key;
#line 67 "../src/properties.vala"
		g_settings_reset (_tmp3_, _tmp4_);
#line 65 "../src/properties.vala"
		_g_free0 (key);
#line 732 "properties.c"
	}
}

void
properties_keys_reset_all (PropertiesKeys* self)
{
#line 71 "../src/properties.vala"
	g_return_if_fail (self != NULL);
#line 741 "properties.c"
	{
		gint index = 0;
#line 72 "../src/properties.vala"
		index = 0;
#line 746 "properties.c"
		{
			gboolean _tmp0_ = FALSE;
#line 72 "../src/properties.vala"
			_tmp0_ = TRUE;
#line 72 "../src/properties.vala"
			while (TRUE) {
#line 753 "properties.c"
				gint _tmp2_;
				gint _tmp3_;
#line 72 "../src/properties.vala"
				if (!_tmp0_) {
#line 758 "properties.c"
					gint _tmp1_;
#line 72 "../src/properties.vala"
					index = index + 1;
#line 72 "../src/properties.vala"
					_tmp1_ = index;
#line 764 "properties.c"
				}
#line 72 "../src/properties.vala"
				_tmp0_ = FALSE;
#line 72 "../src/properties.vala"
				_tmp2_ = properties_keys_get_size (self);
#line 72 "../src/properties.vala"
				_tmp3_ = _tmp2_;
#line 72 "../src/properties.vala"
				if (!(index < _tmp3_)) {
#line 72 "../src/properties.vala"
					break;
#line 776 "properties.c"
				}
#line 73 "../src/properties.vala"
				properties_keys_reset (self, (guint) index);
#line 780 "properties.c"
			}
		}
	}
}

gint
properties_keys_get_size (PropertiesKeys* self)
{
	gint result;
#line 37 "../src/properties.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/properties.vala"
	result = 9;
#line 37 "../src/properties.vala"
	return result;
#line 796 "properties.c"
}

static void
properties_value_keys_init (GValue* value)
{
#line 29 "../src/properties.vala"
	value->data[0].v_pointer = NULL;
#line 804 "properties.c"
}

static void
properties_value_keys_free_value (GValue* value)
{
#line 29 "../src/properties.vala"
	if (value->data[0].v_pointer) {
#line 29 "../src/properties.vala"
		properties_keys_unref (value->data[0].v_pointer);
#line 814 "properties.c"
	}
}

static void
properties_value_keys_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 29 "../src/properties.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "../src/properties.vala"
		dest_value->data[0].v_pointer = properties_keys_ref (src_value->data[0].v_pointer);
#line 826 "properties.c"
	} else {
#line 29 "../src/properties.vala"
		dest_value->data[0].v_pointer = NULL;
#line 830 "properties.c"
	}
}

static gpointer
properties_value_keys_peek_pointer (const GValue* value)
{
#line 29 "../src/properties.vala"
	return value->data[0].v_pointer;
#line 839 "properties.c"
}

static gchar*
properties_value_keys_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 29 "../src/properties.vala"
	if (collect_values[0].v_pointer) {
#line 850 "properties.c"
		PropertiesKeys * object;
		object = collect_values[0].v_pointer;
#line 29 "../src/properties.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "../src/properties.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 857 "properties.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "../src/properties.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 861 "properties.c"
		}
#line 29 "../src/properties.vala"
		value->data[0].v_pointer = properties_keys_ref (object);
#line 865 "properties.c"
	} else {
#line 29 "../src/properties.vala"
		value->data[0].v_pointer = NULL;
#line 869 "properties.c"
	}
#line 29 "../src/properties.vala"
	return NULL;
#line 873 "properties.c"
}

static gchar*
properties_value_keys_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	PropertiesKeys ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "../src/properties.vala"
	if (!object_p) {
#line 29 "../src/properties.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 888 "properties.c"
	}
#line 29 "../src/properties.vala"
	if (!value->data[0].v_pointer) {
#line 29 "../src/properties.vala"
		*object_p = NULL;
#line 894 "properties.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "../src/properties.vala"
		*object_p = value->data[0].v_pointer;
#line 898 "properties.c"
	} else {
#line 29 "../src/properties.vala"
		*object_p = properties_keys_ref (value->data[0].v_pointer);
#line 902 "properties.c"
	}
#line 29 "../src/properties.vala"
	return NULL;
#line 906 "properties.c"
}

GParamSpec*
properties_param_spec_keys (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	PropertiesParamSpecKeys* spec;
#line 29 "../src/properties.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PROPERTIES_TYPE_KEYS), NULL);
#line 29 "../src/properties.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "../src/properties.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "../src/properties.vala"
	return G_PARAM_SPEC (spec);
#line 925 "properties.c"
}

gpointer
properties_value_get_keys (const GValue* value)
{
#line 29 "../src/properties.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PROPERTIES_TYPE_KEYS), NULL);
#line 29 "../src/properties.vala"
	return value->data[0].v_pointer;
#line 935 "properties.c"
}

void
properties_value_set_keys (GValue* value,
                           gpointer v_object)
{
	PropertiesKeys * old;
#line 29 "../src/properties.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PROPERTIES_TYPE_KEYS));
#line 29 "../src/properties.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/properties.vala"
	if (v_object) {
#line 29 "../src/properties.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PROPERTIES_TYPE_KEYS));
#line 29 "../src/properties.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/properties.vala"
		value->data[0].v_pointer = v_object;
#line 29 "../src/properties.vala"
		properties_keys_ref (value->data[0].v_pointer);
#line 957 "properties.c"
	} else {
#line 29 "../src/properties.vala"
		value->data[0].v_pointer = NULL;
#line 961 "properties.c"
	}
#line 29 "../src/properties.vala"
	if (old) {
#line 29 "../src/properties.vala"
		properties_keys_unref (old);
#line 967 "properties.c"
	}
}

void
properties_value_take_keys (GValue* value,
                            gpointer v_object)
{
	PropertiesKeys * old;
#line 29 "../src/properties.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PROPERTIES_TYPE_KEYS));
#line 29 "../src/properties.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/properties.vala"
	if (v_object) {
#line 29 "../src/properties.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PROPERTIES_TYPE_KEYS));
#line 29 "../src/properties.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/properties.vala"
		value->data[0].v_pointer = v_object;
#line 988 "properties.c"
	} else {
#line 29 "../src/properties.vala"
		value->data[0].v_pointer = NULL;
#line 992 "properties.c"
	}
#line 29 "../src/properties.vala"
	if (old) {
#line 29 "../src/properties.vala"
		properties_keys_unref (old);
#line 998 "properties.c"
	}
}

static void
properties_keys_class_init (PropertiesKeysClass * klass,
                            gpointer klass_data)
{
#line 29 "../src/properties.vala"
	properties_keys_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/properties.vala"
	((PropertiesKeysClass *) klass)->finalize = properties_keys_finalize;
#line 29 "../src/properties.vala"
	g_type_class_adjust_private_offset (klass, &PropertiesKeys_private_offset);
#line 1012 "properties.c"
}

static void
properties_keys_instance_init (PropertiesKeys * self,
                               gpointer klass)
{
#line 29 "../src/properties.vala"
	self->priv = properties_keys_get_instance_private (self);
#line 29 "../src/properties.vala"
	self->ref_count = 1;
#line 1023 "properties.c"
}

static void
properties_keys_finalize (PropertiesKeys * obj)
{
	PropertiesKeys * self;
#line 29 "../src/properties.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PROPERTIES_TYPE_KEYS, PropertiesKeys);
#line 29 "../src/properties.vala"
	g_signal_handlers_destroy (self);
#line 30 "../src/properties.vala"
	_g_object_unref0 (self->priv->settings);
#line 1036 "properties.c"
}

static GType
properties_keys_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { properties_value_keys_init, properties_value_keys_free_value, properties_value_keys_copy_value, properties_value_keys_peek_pointer, "p", properties_value_keys_collect_value, "p", properties_value_keys_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesKeysClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_keys_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PropertiesKeys), 0, (GInstanceInitFunc) properties_keys_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType properties_keys_type_id;
	properties_keys_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PropertiesKeys", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PropertiesKeys_private_offset = g_type_add_instance_private (properties_keys_type_id, sizeof (PropertiesKeysPrivate));
	return properties_keys_type_id;
}

GType
properties_keys_get_type (void)
{
	static volatile gsize properties_keys_type_id__once = 0;
	if (g_once_init_enter (&properties_keys_type_id__once)) {
		GType properties_keys_type_id;
		properties_keys_type_id = properties_keys_get_type_once ();
		g_once_init_leave (&properties_keys_type_id__once, properties_keys_type_id);
	}
	return properties_keys_type_id__once;
}

gpointer
properties_keys_ref (gpointer instance)
{
	PropertiesKeys * self;
	self = instance;
#line 29 "../src/properties.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "../src/properties.vala"
	return instance;
#line 1072 "properties.c"
}

void
properties_keys_unref (gpointer instance)
{
	PropertiesKeys * self;
	self = instance;
#line 29 "../src/properties.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "../src/properties.vala"
		PROPERTIES_KEYS_GET_CLASS (self)->finalize (self);
#line 29 "../src/properties.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1086 "properties.c"
	}
}

static void
value_properties_init (GValue* value)
{
#line 20 "../src/properties.vala"
	value->data[0].v_pointer = NULL;
#line 1095 "properties.c"
}

static void
value_properties_free_value (GValue* value)
{
#line 20 "../src/properties.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/properties.vala"
		properties_unref (value->data[0].v_pointer);
#line 1105 "properties.c"
	}
}

static void
value_properties_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 20 "../src/properties.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/properties.vala"
		dest_value->data[0].v_pointer = properties_ref (src_value->data[0].v_pointer);
#line 1117 "properties.c"
	} else {
#line 20 "../src/properties.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1121 "properties.c"
	}
}

static gpointer
value_properties_peek_pointer (const GValue* value)
{
#line 20 "../src/properties.vala"
	return value->data[0].v_pointer;
#line 1130 "properties.c"
}

static gchar*
value_properties_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 20 "../src/properties.vala"
	if (collect_values[0].v_pointer) {
#line 1141 "properties.c"
		Properties * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/properties.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/properties.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1148 "properties.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/properties.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1152 "properties.c"
		}
#line 20 "../src/properties.vala"
		value->data[0].v_pointer = properties_ref (object);
#line 1156 "properties.c"
	} else {
#line 20 "../src/properties.vala"
		value->data[0].v_pointer = NULL;
#line 1160 "properties.c"
	}
#line 20 "../src/properties.vala"
	return NULL;
#line 1164 "properties.c"
}

static gchar*
value_properties_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	Properties ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/properties.vala"
	if (!object_p) {
#line 20 "../src/properties.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1179 "properties.c"
	}
#line 20 "../src/properties.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/properties.vala"
		*object_p = NULL;
#line 1185 "properties.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/properties.vala"
		*object_p = value->data[0].v_pointer;
#line 1189 "properties.c"
	} else {
#line 20 "../src/properties.vala"
		*object_p = properties_ref (value->data[0].v_pointer);
#line 1193 "properties.c"
	}
#line 20 "../src/properties.vala"
	return NULL;
#line 1197 "properties.c"
}

GParamSpec*
param_spec_properties (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecProperties* spec;
#line 20 "../src/properties.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PROPERTIES), NULL);
#line 20 "../src/properties.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/properties.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/properties.vala"
	return G_PARAM_SPEC (spec);
#line 1216 "properties.c"
}

gpointer
value_get_properties (const GValue* value)
{
#line 20 "../src/properties.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROPERTIES), NULL);
#line 20 "../src/properties.vala"
	return value->data[0].v_pointer;
#line 1226 "properties.c"
}

void
value_set_properties (GValue* value,
                      gpointer v_object)
{
	Properties * old;
#line 20 "../src/properties.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROPERTIES));
#line 20 "../src/properties.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/properties.vala"
	if (v_object) {
#line 20 "../src/properties.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROPERTIES));
#line 20 "../src/properties.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/properties.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/properties.vala"
		properties_ref (value->data[0].v_pointer);
#line 1248 "properties.c"
	} else {
#line 20 "../src/properties.vala"
		value->data[0].v_pointer = NULL;
#line 1252 "properties.c"
	}
#line 20 "../src/properties.vala"
	if (old) {
#line 20 "../src/properties.vala"
		properties_unref (old);
#line 1258 "properties.c"
	}
}

void
value_take_properties (GValue* value,
                       gpointer v_object)
{
	Properties * old;
#line 20 "../src/properties.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROPERTIES));
#line 20 "../src/properties.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/properties.vala"
	if (v_object) {
#line 20 "../src/properties.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROPERTIES));
#line 20 "../src/properties.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/properties.vala"
		value->data[0].v_pointer = v_object;
#line 1279 "properties.c"
	} else {
#line 20 "../src/properties.vala"
		value->data[0].v_pointer = NULL;
#line 1283 "properties.c"
	}
#line 20 "../src/properties.vala"
	if (old) {
#line 20 "../src/properties.vala"
		properties_unref (old);
#line 1289 "properties.c"
	}
}

static void
properties_class_init (PropertiesClass * klass,
                       gpointer klass_data)
{
#line 20 "../src/properties.vala"
	properties_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/properties.vala"
	((PropertiesClass *) klass)->finalize = properties_finalize;
#line 20 "../src/properties.vala"
	g_type_class_adjust_private_offset (klass, &Properties_private_offset);
#line 20 "../src/properties.vala"
	properties_signals[PROPERTIES_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PROPERTIES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1305 "properties.c"
}

static void
properties_instance_init (Properties * self,
                          gpointer klass)
{
#line 20 "../src/properties.vala"
	self->priv = properties_get_instance_private (self);
#line 20 "../src/properties.vala"
	self->ref_count = 1;
#line 1316 "properties.c"
}

static void
properties_finalize (Properties * obj)
{
	Properties * self;
	GSettings* _tmp0_;
#line 20 "../src/properties.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROPERTIES, Properties);
#line 20 "../src/properties.vala"
	g_signal_handlers_destroy (self);
#line 160 "../src/properties.vala"
	_tmp0_ = self->priv->settings;
#line 160 "../src/properties.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, self->priv->notify_handler_id);
#line 147 "../src/properties.vala"
	_g_object_unref0 (self->priv->settings);
#line 148 "../src/properties.vala"
	_properties_keys_unref0 (self->priv->_keys);
#line 1336 "properties.c"
}

static GType
properties_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_properties_init, value_properties_free_value, value_properties_copy_value, value_properties_peek_pointer, "p", value_properties_collect_value, "p", value_properties_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Properties), 0, (GInstanceInitFunc) properties_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType properties_type_id;
	properties_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Properties", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Properties_private_offset = g_type_add_instance_private (properties_type_id, sizeof (PropertiesPrivate));
	return properties_type_id;
}

GType
properties_get_type (void)
{
	static volatile gsize properties_type_id__once = 0;
	if (g_once_init_enter (&properties_type_id__once)) {
		GType properties_type_id;
		properties_type_id = properties_get_type_once ();
		g_once_init_leave (&properties_type_id__once, properties_type_id);
	}
	return properties_type_id__once;
}

gpointer
properties_ref (gpointer instance)
{
	Properties * self;
	self = instance;
#line 20 "../src/properties.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/properties.vala"
	return instance;
#line 1372 "properties.c"
}

void
properties_unref (gpointer instance)
{
	Properties * self;
	self = instance;
#line 20 "../src/properties.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/properties.vala"
		PROPERTIES_GET_CLASS (self)->finalize (self);
#line 20 "../src/properties.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1386 "properties.c"
	}
}

